Index: LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2839)
@@ -68,5 +68,5 @@
          o_ue, o_ve, o_uq, o_vq, o_cape, o_pbase, &
          o_ptop, o_fbase, o_plcl, o_plfc, &
-         o_wbeff, o_cape_max, o_upwd, o_ep,o_epmax_diag, o_Ma, &
+         o_wbeff, o_convoccur, o_cape_max, o_upwd, o_ep,o_epmax_diag, o_Ma, &
          o_dnwd, o_dnwd0, o_ftime_con, o_mc, &
          o_prw, o_prlw, o_prsw, o_s_pblh, o_s_pblt, o_s_lcl, &
@@ -99,5 +99,5 @@
          o_SWdownOR, o_LWdownOR, o_snowl, &
          o_solldown, o_dtsvdfo, o_dtsvdft, &
-         o_dtsvdfg, o_dtsvdfi, o_z0m, o_z0h, o_od550aer, &
+         o_dtsvdfg, o_dtsvdfi, o_z0m, o_z0h, o_od443aer, o_od550aer, &
          o_od865aer, o_absvisaer, o_od550lt1aer, &
          o_sconcso4, o_sconcno3, o_sconcoa, o_sconcbc, &
@@ -105,5 +105,5 @@
          o_concoa, o_concbc, o_concss, o_concdust, &
          o_loadso4, o_loadoa, o_loadbc, o_loadss, &
-         o_loaddust, o_tausumaero, o_tausumaero_lw, &
+         o_loaddust, o_loadno3, o_tausumaero, o_tausumaero_lw, &
          o_topswad, o_topswad0, o_solswad, o_solswad0, &
          o_toplwad, o_toplwad0, o_sollwad, o_sollwad0, &
@@ -196,5 +196,5 @@
 #endif
 
-    USE phys_state_var_mod, ONLY: pctsrf, paire_ter, rain_fall, snow_fall, &
+    USE phys_state_var_mod, ONLY: pctsrf, rain_fall, snow_fall, &
          qsol, z0m, z0h, fevap, agesno, &
          nday_rain, rain_con, snow_con, &
@@ -236,5 +236,5 @@
          cldh, cldt, JrNt, cldljn, cldmjn, cldhjn, &
          cldtjn, cldq, flwp, fiwp, ue, ve, uq, vq, &
-         plcl, plfc, wbeff, upwd, dnwd, dnwd0, prw, prlw, prsw, &
+         plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw, &
          s_pblh, s_pblt, s_lcl, s_therm, uwriteSTD, &
          vwriteSTD, wwriteSTD, phiwriteSTD, qwriteSTD, &
@@ -252,9 +252,9 @@
          weak_inversion, dthmin, cldtau, cldemi, &
          pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
-         qsat2m, tpote, tpot, d_ts, od550aer, &
+         qsat2m, tpote, tpot, d_ts, od443aer, od550aer, &
          od865aer, absvisaer, od550lt1aer, sconcso4, sconcno3, &
          sconcoa, sconcbc, sconcss, sconcdust, concso4, concno3, &
          concoa, concbc, concss, concdust, loadso4, &
-         loadoa, loadbc, loadss, loaddust, tausum_aero, &
+         loadoa, loadbc, loadss, loaddust, loadno3, tausum_aero, &
          topswad_aero, topswad0_aero, solswad_aero, &
          solswad0_aero, topsw_aero, solsw_aero, &
@@ -325,5 +325,4 @@
     USE geometry_mod, ONLY: cell_area
     USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, ok_snow
-!    USE aero_mod, ONLY: naero_spc
     USE aero_mod, ONLY: naero_tot, id_STRAT_phy
     USE ioipsl, ONLY: histend, histsync
@@ -410,5 +409,6 @@
 #ifdef CPP_XIOS
 #ifdef CPP_StratAer
-    IF (.NOT.vars_defined) THEN
+!$OMP MASTER
+   IF (.NOT.vars_defined) THEN
           !On ajoute les variables 3D traceurs par l interface fortran 
           CALL xios_get_handle("fields_strataer_trac_3D", group_handle)
@@ -474,7 +474,7 @@
           ENDDO
     ENDIF
-#endif
-#endif
-
+!$OMP END MASTER
+#endif
+#endif
     ! ug la boucle qui suit ne sert qu'une fois, pour l'initialisation, sinon il n'y a toujours qu'un seul passage:
     DO iinit=1, iinitend
@@ -513,5 +513,4 @@
        CALL histwrite_phy(o_contfracATM, zx_tmp_fi2d)
        CALL histwrite_phy(o_contfracOR, pctsrf(:,is_ter))
-       CALL histwrite_phy(o_aireTER, paire_ter)
 !
 #ifdef CPP_XIOS
@@ -739,7 +738,5 @@
        CALL histwrite_phy(o_bils_diss, bils_diss)
        CALL histwrite_phy(o_bils_ec, bils_ec)
-       IF (iflag_ener_conserv>=1) THEN
-         CALL histwrite_phy(o_bils_ech, bils_ech)
-       ENDIF
+       CALL histwrite_phy(o_bils_ech, bils_ech)
        CALL histwrite_phy(o_bils_tke, bils_tke)
        CALL histwrite_phy(o_bils_kinetic, bils_kinetic)
@@ -890,4 +887,5 @@
              CALL histwrite_phy(o_plfc, plfc)
              CALL histwrite_phy(o_wbeff, wbeff)
+             CALL histwrite_phy(o_convoccur, convoccur)
           ENDIF
 
@@ -1172,4 +1170,5 @@
        IF (new_aod) THEN
           IF (flag_aerosol.GT.0) THEN
+             CALL histwrite_phy(o_od443aer, od443aer)
              CALL histwrite_phy(o_od550aer, od550aer)
              CALL histwrite_phy(o_od865aer, od865aer)
@@ -1193,4 +1192,5 @@
              CALL histwrite_phy(o_loadss, loadss)
              CALL histwrite_phy(o_loaddust, loaddust)
+             CALL histwrite_phy(o_loadno3, loadno3)
              !--STRAT AER
           ENDIF
Index: LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2839)
@@ -275,6 +275,4 @@
       REAL,ALLOCATABLE,SAVE :: total_rain(:), nday_rain(:)  
 !$OMP THREADPRIVATE(total_rain,nday_rain)
-      REAL,ALLOCATABLE,SAVE :: paire_ter(:)
-!$OMP THREADPRIVATE(paire_ter)
 ! albsol1: albedo du sol total pour SW visible
 ! albsol2: albedo du sol total pour SW proche IR
@@ -536,5 +534,4 @@
       ALLOCATE(pfrac_1nucl(klon,klev))
       ALLOCATE(total_rain(klon), nday_rain(klon))
-      ALLOCATE(paire_ter(klon))
       ALLOCATE(albsol1(klon), albsol2(klon))
 !albedo SB >>>
@@ -675,5 +672,4 @@
       deallocate(pfrac_1nucl)
       deallocate(total_rain, nday_rain)
-      deallocate(paire_ter)
       deallocate(albsol1, albsol2)
 !albedo SB >>>
Index: LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2839)
@@ -35,4 +35,5 @@
     USE change_srf_frac_mod
     USE surface_data,     ONLY : type_ocean, ok_veget, ok_snow
+    USE tropopause_m,     ONLY: dyn_tropopause
 #ifdef CPP_Dust
     USE phytracr_spl_mod, ONLY: phytracr_spl
@@ -154,5 +155,5 @@
 !!!       d_s_the, d_dens_the, &            ! due to thermals
        !                                  
-       wbeff, zmax_th, &
+       wbeff, convoccur, zmax_th, &
        sens, flwp, fiwp,  &
        ale_bl_stat,alp_bl_conv,alp_bl_det,  &
@@ -191,5 +192,6 @@
        beta_prec,  &
        rneb,  &
-       zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic
+       zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic, &
+       pr_tropopause
        !
     USE phys_state_var_mod ! Variables sauvegardees de la physique
@@ -205,5 +207,5 @@
     USE phys_output_ctrlout_mod
     use open_climoz_m, only: open_climoz ! ozone climatology from a file
-    use regr_pr_av_m, only: regr_pr_av
+    use regr_pr_time_av_m, only: regr_pr_time_av
     use netcdf95, only: nf95_close
     !IM for NMC files
@@ -240,4 +242,6 @@
 
     USE cmp_seri_mod
+    USE add_phys_tend_mod, only : add_pbl_tend, add_phys_tend, prt_enerbil, &
+  &      fl_ebil, fl_cor_ebil
 
     !IM stations CFMIP
@@ -245,4 +249,6 @@
     use FLOTT_GWD_rando_m, only: FLOTT_GWD_rando
     use ACAMA_GWD_rando_m, only: ACAMA_GWD_rando
+    USE VERTICAL_LAYERS_MOD, ONLY: aps,bps
+
 
     IMPLICIT none
@@ -404,6 +410,6 @@
     REAL pphis(klon)
     REAL presnivs(klev)
-    REAL znivsig(klev)
-    real pir
+!JLD    REAL znivsig(klev)
+!JLD    real pir
 
     REAL u(klon,klev)
@@ -465,6 +471,6 @@
     ! jmin_debut : indice minimum de j; nbptj : nombre de points en
     ! direction j (latitude)
-    INTEGER imin_debut, nbpti
-    INTEGER jmin_debut, nbptj 
+!JLD    INTEGER imin_debut, nbpti
+!JLD    INTEGER jmin_debut, nbptj 
     !IM: region='3d' <==> sorties en global
     CHARACTER*3 region
@@ -530,4 +536,9 @@
     REAL Tconv(klon,klev)
     REAL sij(klon,klev,klev)
+!!    !
+!!    ! variables pour tester la conservation de l'energie dans concvl
+!!    REAL, DIMENSION(klon,klev)     :: d_t_con_sat
+!!    REAL, DIMENSION(klon,klev)     :: d_q_con_sat
+!!    REAL, DIMENSION(klon,klev)     :: dql_sat
 
     real, save :: alp_bl_prescr=0.
@@ -615,6 +626,6 @@
     real env_tke_max0(klon)     ! TKE dans l'environnement au LCL 
 
-    !---D\'eclenchement stochastique
-    integer :: tau_trig(klon)
+!JLD    !---D\'eclenchement stochastique
+!JLD    integer :: tau_trig(klon)
 
     REAL,SAVE :: random_notrig_max=1.
@@ -650,5 +661,4 @@
     REAL beta_prec_fisrt(klon,klev) ! taux de conv de l'eau cond (fisrt)
     ! RomP <<<
-
     REAL          :: calday
 
@@ -749,5 +759,7 @@
     REAL conv_t(klon,klev) ! convergence de la temperature(K/s)
     !
+#ifdef INCA
     REAL zxsnow_dummy(klon)
+#endif
     REAL zsav_tsol(klon)
     !
@@ -760,9 +772,9 @@
     LOGICAL zx_ajustq
     !
-    REAL za, zb
-    REAL zx_t, zx_qs, zdelta, zcor, zlvdcp, zlsdcp
+    REAL za
+    REAL zx_t, zx_qs, zdelta, zcor
     real zqsat(klon,klev)
     !
-    INTEGER i, k, iq, j, nsrf, ll, l
+    INTEGER i, k, iq, nsrf, l
     !
     REAL t_coup
@@ -820,4 +832,6 @@
     REAL, dimension(klon)     :: dsig0, ddens0
     INTEGER, dimension(klon)  :: wkoccur1
+    ! tendance buffer pour appel de add_phys_tend
+    REAL, DIMENSION(klon,klev)  :: d_q_ch4_dtime
     !
     ! Flag pour pouvoir ne pas ajouter les tendances. 
@@ -872,5 +886,5 @@
 
     !
-    integer itau_w   ! pas de temps ecriture = itap + itau_phy
+!JLD    integer itau_w   ! pas de temps ecriture = itap + itau_phy
     !
     !
@@ -884,9 +898,9 @@
     REAL tabcntr0( length       )
     !
-    INTEGER ndex2d(nbp_lon*nbp_lat)
+!JLD    INTEGER ndex2d(nbp_lon*nbp_lat)
     !IM
     !
     !IM AMIP2 BEG
-    REAL moyglo, mountor
+!JLD    REAL moyglo, mountor
     !IM 141004 BEG
     REAL zustrdr(klon), zvstrdr(klon)
@@ -902,6 +916,6 @@
     !  REAL airedyn(nbp_lon+1,nbp_lat)
     !IM 190504 END
-    LOGICAL ok_msk
-    REAL msk(klon)
+!JLD    LOGICAL ok_msk
+!JLD    REAL msk(klon)
     !ym A voir plus tard
     !ym      REAL zm_wo(jjmp1, klev)
@@ -910,7 +924,7 @@
     REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
     REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
-    REAL zx_tmp_2d(nbp_lon,nbp_lat)
-    REAL zx_lon(nbp_lon,nbp_lat)
-    REAL zx_lat(nbp_lon,nbp_lat)
+!JLD    REAL zx_tmp_2d(nbp_lon,nbp_lat)
+!JLD    REAL zx_lon(nbp_lon,nbp_lat)
+!JLD    REAL zx_lat(nbp_lon,nbp_lat)
     !
     INTEGER nid_ctesGCM
@@ -928,11 +942,11 @@
     REAL uq_lay(klon,klev) ! transport zonal de l'eau a chaque niveau vert.
     !
-    REAL zjulian
-    SAVE zjulian
-!$OMP THREADPRIVATE(zjulian)
-
-    INTEGER nhori, nvert
-    REAL zsto
-    REAL zstophy, zout
+!JLD    REAL zjulian
+!JLD    SAVE zjulian
+!JLD!$OMP THREADPRIVATE(zjulian)
+
+!JLD    INTEGER nhori, nvert
+!JLD    REAL zsto
+!JLD    REAL zstophy, zout
 
     character*20 modname
@@ -948,22 +962,10 @@
     parameter (prof2d_on = 1, prof3d_on = 2, &
          prof2d_av = 3, prof3d_av = 4)
-    !     Variables liees au bilan d'energie et d'enthalpi
     REAL ztsol(klon)
-    REAL      d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
-    REAL      d_h_vcol_phy
-    REAL      fs_bound, fq_bound
-    SAVE      d_h_vcol_phy
-    !$OMP THREADPRIVATE(d_h_vcol_phy)
-    REAL      zero_v(klon)
-    CHARACTER*40 ztit
-    INTEGER   ip_ebil  ! PRINT level for energy conserv. diag.
-    SAVE      ip_ebil
-    DATA      ip_ebil/0/
-    !$OMP THREADPRIVATE(ip_ebil)
     REAL q2m(klon,nbsrf)  ! humidite a 2m
 
     !IM: t2m, q2m, ustar, u10m, v10m et t2mincels, t2maxcels
     CHARACTER*40 t2mincels, t2maxcels       !t2m min., t2m max
-    CHARACTER*40 tinst, tave, typeval
+    CHARACTER*40 tinst, tave
     REAL cldtaupi(klon,klev) ! Cloud optical thickness for
     ! pre-industrial (pi) aerosols
@@ -1006,5 +1008,7 @@
     !$OMP THREADPRIVATE(first)
 
-    integer, save::  read_climoz ! read ozone climatology
+    ! VARIABLES RELATED TO OZONE CLIMATOLOGIES ; all are OpenMP shared
+    ! Note that pressure vectors are in Pa and in stricly ascending order
+    INTEGER,SAVE :: read_climoz                ! Read ozone climatology
     !     (let it keep the default OpenMP shared attribute)
     !     Allowed values are 0, 1 and 2
@@ -1013,18 +1017,15 @@
     !     2: read two ozone climatologies, the average day and night
     !     climatology and the daylight climatology
-
-    integer, save:: ncid_climoz ! NetCDF file containing ozone climatologies
-    !     (let it keep the default OpenMP shared attribute)
-
-    real, pointer, save:: press_climoz(:)
-    ! (let it keep the default OpenMP shared attribute)
-    ! edges of pressure intervals for ozone climatologies, in Pa, in strictly
-    ! ascending order
-
-    integer ro3i
-    !     required time index in NetCDF file for the ozone fields, between 1
-    !     and 360
-
-    INTEGER ierr
+    INTEGER,SAVE :: ncid_climoz                ! NetCDF file identifier
+    REAL, POINTER, SAVE :: press_cen_climoz(:) ! Pressure levels
+    REAL, POINTER, SAVE :: press_edg_climoz(:) ! Edges of pressure intervals
+    REAL, POINTER, SAVE :: time_climoz(:)      ! Time vector
+    CHARACTER(LEN=13), PARAMETER :: vars_climoz(2) &
+                                  = ["tro3         ","tro3_daylight"]
+    ! vars_climoz(1:read_climoz): variables names in climoz file.
+    ! vars_climoz(1:read_climoz-2) if read_climoz>2 (temporary)
+    REAL :: ro3i ! 0<=ro3i<=360 ; required time index in NetCDF file for
+                 ! the ozone fields, old method.
+
     include "YOMCST.h"
     include "YOETHF.h"
@@ -1040,6 +1041,7 @@
     ! Declarations pour Simulateur COSP
     !============================================================
+#ifdef CPP_COSP
     real :: mr_ozone(klon,klev)
-
+#endif
     !IM stations CFMIP
     INTEGER, SAVE :: nCFMIP
@@ -1090,5 +1092,5 @@
     !--OB variables for mass fixer (hard coded for now)
     logical, parameter :: mass_fixer=.false.
-    real qql1(klon),qql2(klon),zdz,corrqql
+    real qql1(klon),qql2(klon),corrqql
 
     ! Ehouarn: set value of jjmp1 since it is no longer a "fixed parameter"
@@ -1194,10 +1196,4 @@
 
     modname = 'physiq'
-    !IM
-    IF (ip_ebil_phy.ge.1) THEN
-       DO i=1,klon
-          zero_v(i)=0.
-       ENDDO
-    ENDIF
 
     IF (debut) THEN
@@ -1211,4 +1207,11 @@
        iflag_wake_tend = 0
        CALL getin_p('iflag_wake_tend',iflag_wake_tend)
+       ok_bad_ecmwf_thermo=.TRUE. ! By default thermodynamical constants are set 
+                                  ! in rrtm/suphec.F90 (and rvtmp2 is set to 0).
+       CALL getin_p('ok_bad_ecmwf_thermo',ok_bad_ecmwf_thermo)
+       fl_ebil = 0 ! by default, conservation diagnostics are desactivated
+       CALL getin_p('fl_ebil',fl_ebil)
+       fl_cor_ebil = 0 ! by default, no correction to ensure energy conservation
+       CALL getin_p('fl_cor_ebil',fl_cor_ebil)
     ENDIF
 
@@ -1274,6 +1277,4 @@
        clwcon(:,:) = 0.0
 
-       !IM      
-       IF (ip_ebil_phy.ge.1) d_h_vcol_phy=0.
        !
        print*,'iflag_coupl,iflag_clos,iflag_wake', &
@@ -1656,4 +1657,5 @@
                start_time, &
                itau_phy, &
+               date0, &
                io_lon, &
                io_lat)
@@ -1671,7 +1673,6 @@
 
        !$omp single
-       IF (read_climoz >= 1) THEN
-          CALL open_climoz(ncid_climoz, press_climoz)
-       ENDIF
+       IF (read_climoz >= 1) CALL open_climoz(ncid_climoz, press_cen_climoz,   &
+           press_edg_climoz, time_climoz, ok_daily_climoz, adjust_tropopause)
        !$omp end single
        !
@@ -1737,8 +1738,9 @@
     !
     itap   = itap + 1
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master .OR. prt_level > 9) THEN
       IF (prt_level > 5 .or. MOD(itap,5) == 0) THEN
-         WRITE(LUNOUT,*)'Entering physics current time = ', current_time
-         WRITE(LUNOUT,*)'Date = ',year_cur,'/',mth_cur,'/',day_cur,':',hour/3600
+         WRITE(LUNOUT,*)'Entering physics elapsed seconds since start ', current_time
+         WRITE(LUNOUT,100)year_cur,mth_cur,day_cur,hour/3600.
+ 100     FORMAT('Date = ',i4.4,' / ',i2.2, ' / ',i2.2,' : ',f20.17)
       ENDIF
     ENDIF
@@ -1978,24 +1980,23 @@
           wo(:,:,1)=ozonecm(latitude_deg, paprs,read_climoz,rjour=zzz)
        ELSE
-          ro3i = int((days_elapsed + jh_cur - jh_1jan) / year_len * 360.) + 1
-
-          IF (ro3i == 361) ro3i = 360
-          ! (This should never occur, except perhaps because of roundup
-          ! error. See documentation.)
-
-          IF (read_climoz == 1) THEN
-             CALL regr_pr_av(ncid_climoz, (/"tro3"/), julien=ro3i, &
-                  press_in_edg=press_climoz, paprs=paprs, v3=wo)
+          !--- ro3i = elapsed days number since current year 1st january, 0h
+          ro3i=days_elapsed+jh_cur-jh_1jan
+          !--- scaling for old style files (360 records)
+          IF(SIZE(time_climoz)==360.AND..NOT.ok_daily_climoz) ro3i=ro3i*360./year_len
+          IF(adjust_tropopause) THEN
+             CALL dyn_tropopause(t_seri, ztsol, paprs, pplay, presnivs, rot, &
+                  pr_tropopause)
+             CALL regr_pr_time_av(ncid_climoz, vars_climoz(1:read_climoz),   &
+                      ro3i,  press_edg_climoz,  paprs,   wo, time_climoz,    &
+                           latitude_deg,  press_cen_climoz,  pr_tropopause)
           ELSE
-             ! read_climoz == 2
-             CALL regr_pr_av(ncid_climoz, (/"tro3         ", &
-                  "tro3_daylight"/), julien=ro3i, press_in_edg=press_climoz, &
-                  paprs=paprs, v3=wo)
-          ENDIF
+             CALL regr_pr_time_av(ncid_climoz, vars_climoz(1:read_climoz),   &
+                      ro3i,  press_edg_climoz,  paprs,  wo,  time_climoz)
+          END IF
           ! Convert from mole fraction of ozone to column density of ozone in a
           ! cell, in kDU:
           FORALL (l = 1: read_climoz) wo(:, :, l) = wo(:, :, l) * rmo3 / rmd &
                * zmasse / dobson_u / 1e3
-          ! (By regridding ozone values for LMDZ only once per day, we
+          ! (By regridding ozone values for LMDZ only once a day, we
           ! have already neglected the variation of pressure in one
           ! day. So do not recompute "wo" at each time step even if
@@ -2011,5 +2012,6 @@
      CALL add_phys_tend &
             (du0,dv0,d_t_eva,d_q_eva,d_ql_eva,d_qi_eva,paprs,&
-               'eva',abortphy,flag_inhib_tend)
+               'eva',abortphy,flag_inhib_tend,itap,0)
+    call prt_enerbil('eva',itap)
 
     !=========================================================================
@@ -2233,10 +2235,11 @@
           CALL add_pbl_tend &
                (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
-               'vdf',abortphy,flag_inhib_tend)
+               'vdf',abortphy,flag_inhib_tend,itap)
        ELSE
           CALL add_phys_tend &
                (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
-               'vdf',abortphy,flag_inhib_tend)
-       ENDIF
+               'vdf',abortphy,flag_inhib_tend,itap,0)
+       ENDIF
+       call prt_enerbil('vdf',itap)
        !--------------------------------------------------------------------
 
@@ -2485,5 +2488,5 @@
                d_t_con,d_q_con,d_u_con,d_v_con,d_tr, &
                rain_con, snow_con, ibas_con, itop_con, sigd, &
-               ema_cbmf,plcl,plfc,wbeff,upwd,dnwd,dnwd0, &
+               ema_cbmf,plcl,plfc,wbeff,convoccur,upwd,dnwd,dnwd0, &
                Ma,mip,Vprecip,cape,cin,tvp,Tconv,iflagctrl, &
                pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd, &
@@ -2618,6 +2621,18 @@
     itapcv = itapcv+1
 
+!!!jyg  Appel diagnostique a add_phys_tend pour tester la conservation de 
+!!!     l'energie dans les courants satures.
+!!    d_t_con_sat(:,:) = d_t_con(:,:) - ftd(:,:)*dtime
+!!    d_q_con_sat(:,:) = d_q_con(:,:) - fqd(:,:)*dtime
+!!    dql_sat(:,:) = (wdtrainA(:,:)+wdtrainM(:,:))*dtime/zmasse(:,:)
+!!    CALL add_phys_tend(d_u_con, d_v_con, d_t_con_sat, d_q_con_sat, dql_sat,   &
+!!                     dqi0, paprs, 'convection_sat', abortphy, flag_inhib_tend,&  
+!!                     itap, 1)
+!!    call prt_enerbil('convection_sat',itap)
+!!
+!!
     CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, paprs, &
-         'convection',abortphy,flag_inhib_tend)
+         'convection',abortphy,flag_inhib_tend,itap,0)
+    call prt_enerbil('convection',itap)
 
     !-------------------------------------------------------------------------
@@ -2748,5 +2763,6 @@
        ! ajout des tendances des poches froides
        CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake', &
-            abortphy,flag_inhib_tend)
+            abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('wake',itap)
        !------------------------------------------------------------------------
 
@@ -2757,5 +2773,5 @@
             (d_deltat_wk, d_deltaq_wk, d_s_wk, d_dens_wk, wake_k, &
              'wake', abortphy) 
-
+          call prt_enerbil('wake',itap)
        ENDIF   ! (iflag_wake_tend .GT. 0.)
 
@@ -2878,9 +2894,11 @@
              CALL add_wake_tend &
                  (d_deltat_the, d_deltaq_the, dsig0, ddens0, wkoccur1, 'the', abortphy) 
+             call prt_enerbil('the',itap)
           !
           ENDIF  ! (mod(iflag_pbl_split/2,2) .EQ. 1)
           !
           CALL add_phys_tend(d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs,  &
-                             dql0,dqi0,paprs,'thermals', abortphy,flag_inhib_tend)
+                             dql0,dqi0,paprs,'thermals', abortphy,flag_inhib_tend,itap,0)
+          call prt_enerbil('thermals',itap)
           !
 !
@@ -2944,5 +2962,6 @@
           ! ajout des tendances de l'ajustement sec ou des thermiques
           CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs, &
-               'ajsb',abortphy,flag_inhib_tend)
+               'ajsb',abortphy,flag_inhib_tend,itap,0)
+          call prt_enerbil('ajsb',itap)
           d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
           d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
@@ -2987,6 +3006,13 @@
     WHERE (snow_lsc < 0) snow_lsc = 0.
 
+!+JLD
+!    write(*,9000) 'phys lsc',"enerbil: bil_q, bil_e,",rain_lsc+snow_lsc &
+!        & ,((rcw-rcpd)*rain_lsc + (rcs-rcpd)*snow_lsc)*t_seri(1,1)-rlvtt*rain_lsc+rlstt*snow_lsc &
+!        & ,rain_lsc,snow_lsc
+!    write(*,9000) "rcpv","rcw",rcpv,rcw,rcs,t_seri(1,1)
+!-JLD 
     CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs, &
-         'lsc',abortphy,flag_inhib_tend)
+         'lsc',abortphy,flag_inhib_tend,itap,0)
+    call prt_enerbil('lsc',itap)
     rain_num(:)=0.
     DO k = 1, klev
@@ -3767,6 +3793,8 @@
     ENDDO
 
-    CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy,flag_inhib_tend)
-    CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy,flag_inhib_tend)
+    CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy,flag_inhib_tend,itap,0)
+    call prt_enerbil('SW',itap)
+    CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy,flag_inhib_tend,itap,0)
+    call prt_enerbil('LW',itap)
 
     !
@@ -3838,5 +3866,6 @@
        ! ajout des tendances de la trainee de l'orographie
        CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro', &
-            abortphy,flag_inhib_tend)
+            abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('oro',itap)
        !----------------------------------------------------------------------
        !
@@ -3884,5 +3913,6 @@
        ! ajout des tendances de la portance de l'orographie
        CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
-            'lif', abortphy,flag_inhib_tend)
+            'lif', abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('lif',itap)
     ENDIF ! fin de test sur ok_orolf
 
@@ -3907,5 +3937,6 @@
        d_t_hin(:, :)=0.
        CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, &
-            dqi0, paprs, 'hin', abortphy,flag_inhib_tend)
+            dqi0, paprs, 'hin', abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('hin',itap)
     ENDIF
 
@@ -3924,5 +3955,6 @@
 
        CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
-            paprs, 'front_gwd_rando', abortphy,flag_inhib_tend)
+            paprs, 'front_gwd_rando', abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('front_gwd_rando',itap)
     ENDIF
 
@@ -3932,5 +3964,6 @@
             du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
        CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
-            paprs, 'flott_gwd_rando', abortphy,flag_inhib_tend)
+            paprs, 'flott_gwd_rando', abortphy,flag_inhib_tend,itap,0)
+       call prt_enerbil('flott_gwd_rando',itap)
        zustr_gwd_rando=0.
        zvstr_gwd_rando=0.
@@ -3981,6 +4014,8 @@
        CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
        ! ajout de la tendance d'humidite due au methane
-       CALL add_phys_tend(du0, dv0, dt0, d_q_ch4*dtime, dql0, dqi0, paprs, &
-            'q_ch4', abortphy,flag_inhib_tend)
+       d_q_ch4_dtime(:,:) = d_q_ch4(:,:)*dtime
+       CALL add_phys_tend(du0, dv0, dt0, d_q_ch4_dtime, dql0, dqi0, paprs, &
+            'q_ch4', abortphy,flag_inhib_tend,itap,0)
+       d_q_ch4(:,:) = d_q_ch4_dtime(:,:)/dtime
     ENDIF
     !
@@ -4004,5 +4039,5 @@
           CALL phys_cosp(itap,dtime,freq_cosp, &
                ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
-               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
                klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
                JrNt,ref_liq,ref_ice, &
@@ -4211,5 +4246,6 @@
             pphi, &
             pphis, &
-            zx_rh)
+            zx_rh, &
+            aps, bps)
 
        CALL VTe(VTinca)
@@ -4465,5 +4501,6 @@
              CALL nf95_close(ncid_climoz)
           ENDIF
-          DEALLOCATE(press_climoz) ! pointer
+          DEALLOCATE(press_edg_climoz) ! pointer
+          DEALLOCATE(press_cen_climoz) ! pointer
        ENDIF
        !$OMP END MASTER
Index: LMDZ5/branches/testing/libf/phylmd/readaerosol.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/readaerosol.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/readaerosol.F90	(revision 2839)
@@ -222,11 +222,11 @@
     REAL, ALLOCATABLE, DIMENSION(:)       :: varktmp
 
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)         :: psurf_glo2D   ! Surface pression for 12 months on dynamics global grid
+    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: psurf_glo2D   ! Surface pression for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: psurf_glo1D   ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)         :: load_glo2D    ! Load for 12 months on dynamics global grid
+    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: load_glo2D    ! Load for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: load_glo1D    ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat)            :: vartmp
-    REAL, DIMENSION(nbp_lon)                  :: lon_src              ! longitudes in file
-    REAL, DIMENSION(nbp_lat)                :: lat_src, lat_src_inv ! latitudes in file
+    REAL, DIMENSION(nbp_lon,nbp_lat)      :: vartmp
+    REAL, DIMENSION(nbp_lon)              :: lon_src              ! longitudes in file
+    REAL, DIMENSION(nbp_lat)              :: lat_src, lat_src_inv ! latitudes in file
     LOGICAL                               :: new_file             ! true if new file format detected
     LOGICAL                               :: invert_lat           ! true if the field has to be inverted for latitudes
@@ -245,5 +245,5 @@
   
        WRITE(lunout,*) 'reading variable ',TRIM(varname),' in file ', TRIM(fname)
-       CALL check_err( nf90_open(TRIM(fname), NF90_NOWRITE, ncid), "pb open "//trim(varname) )
+       CALL check_err( nf90_open(TRIM(fname), NF90_NOWRITE, ncid), "pb open "//trim(fname) )
 
 ! Test for equal longitudes and latitudes in file and model
@@ -338,8 +338,14 @@
 !****************************************************************************************
           ! Get variable id
-          CALL check_err( nf90_inq_varid(ncid, TRIM(varname), varid),"pb inq var "//TRIM(varname) )
-          
-          ! Get the variable
-          CALL check_err( nf90_get_var(ncid, varid, varyear(:,:,:,:)),"pb get var "//TRIM(varname) )
+          !CALL check_err( nf90_inq_varid(ncid, TRIM(varname), varid),"pb inq var "//TRIM(varname) )
+          print *,'readaerosol ', TRIM(varname)
+          IF ( nf90_inq_varid(ncid, TRIM(varname), varid) /= NF90_NOERR ) THEN 
+            ! Variable is not there
+            WRITE(lunout,*) 'Attention '//TRIM(varname)//' is not in aerosol input file'
+            varyear(:,:,:,:)=0.0
+          ELSE 
+            ! Get the variable
+            CALL check_err( nf90_get_var(ncid, varid, varyear(:,:,:,:)),"pb get var "//TRIM(varname) )
+          ENDIF
           
 ! ++) Read surface pression, 12 month in one variable
@@ -353,7 +359,12 @@
 !****************************************************************************************
           ! Get variable id
-          CALL check_err( nf90_inq_varid(ncid, "load_"//TRIM(varname), varid) ,"pb inq var load_"//TRIM(varname))
-          ! Get the variable
-          CALL check_err( nf90_get_var(ncid, varid, load_glo2D),"pb get var load_"//TRIM(varname) )
+          !CALL check_err( nf90_inq_varid(ncid, "load_"//TRIM(varname), varid) ,"pb inq var load_"//TRIM(varname))
+          IF ( nf90_inq_varid(ncid, "load_"//TRIM(varname), varid) /= NF90_NOERR ) THEN 
+            WRITE(lunout,*) 'Attention load_'//TRIM(varname)//' is not in aerosol input file'
+            load_glo2D(:,:,:)=0.0
+          ELSE
+            ! Get the variable
+            CALL check_err( nf90_get_var(ncid, varid, load_glo2D),"pb get var load_"//TRIM(varname) )
+          ENDIF
           
 ! ++) Read ap
